#include <stdio.h>
#ifdef RF_OPT_PCMCU_PLAT
#include <Windows.h>
#endif
#include "rfs.h"
#include "ex-rfs.h"

void show_error_stop_imp(rf_char_t* info)
{
    printf("%s error [%s]\n", info, rf_strerror(rf_errno));
#ifdef WIN32
#ifdef _DEBUG
    DebugBreak();
#else
    exit(1);
#endif
#else
    while (1);
#endif
}

/* ӡ */
void check_ret_error_stop(rf_char_t* info, rf_int_t ret)
{
    if (ret < 0) {
        show_error_stop_imp(info);
    }
}

/* дļֵ */
void check_ssize_error_stop(rf_char_t* info, rf_ssize_t size)
{
    if (size < 0) {
        show_error_stop_imp(info);
    }
}

#if RF_OPT_USE_MKFS
rf_int_t format_ex(rf_char_t* dev)
{
    rf_fat_mkfs_param_t mp;
    rf_int_t ret;

    /* ݿռС Զѡʵfat иʽ */
    /* mp.fat_type = RF_TYPE_FAT12 fat12ļϵͳ */
    /* mp.fat_type = RF_TYPE_FAT16 fat16ļϵͳ */
    /* mp.fat_type = RF_TYPE_FAT32 fat32ļϵͳ */
    /* 0 ʾݷ fat */
    mp.fat_type = 0;
    /* fat ֧1  2 */
    mp.fat_size = 1;
    /* 0 ʾ̬ȡֽ */
    mp.sector_size = 0;
    /* 0 ݷ ѡʵĴشС */
    mp.cluster_size = 0;
    /* 0 ƫ */
    mp.volume_offset = 0;
    /* 0 ̬ȡ  */
    mp.volume_size = 0;
    ret = rf_mkfs("fat", dev, &mp);
    check_ret_error_stop("rf_mkfs", ret);
    return ret;
}
#endif

#ifdef RF_OPT_PCMCU_PLAT
int creat_img_file(char* name, int size)
{
    HANDLE hFile;

    hFile = CreateFile(name, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
    if (hFile == INVALID_HANDLE_VALUE) {
        printf("CreateFile [%s] error\n", name);
        exit(1);
    }
    SetFilePointer(hFile, size, NULL, FILE_BEGIN);
    if (!SetEndOfFile(hFile)) {
        printf("SetEndOfFile [%s] error\n", name);
        exit(1);
    }
    CloseHandle(hFile);
    return 0;
}

rf_bool_t path_remove_filespec(rf_char_t* pszPath);
int init_img_file(char* dev_name1, char* dev_name2)
{
    char buf[RF_MAX_PATH];

    GetModuleFileName(NULL, buf, sizeof(buf));
    path_remove_filespec(buf);
    sprintf_s(dev_name1, RF_MAX_PATH, "%s\\test1.img", buf);
    creat_img_file(dev_name1, 64 * 1024 * 1024);
    sprintf_s(dev_name2, RF_MAX_PATH, "%s\\test2.img", buf);
    creat_img_file(dev_name2, 64 * 1024 * 1024);

    sprintf_s(dev_name1, RF_MAX_PATH, "file\t%s\\test1.img", buf);
    sprintf_s(dev_name2, RF_MAX_PATH, "file\t%s\\test2.img", buf);
    return 0;
}
#endif

int main()
{
    int ret, i;
    rf_mount_ctx_t mc = { 0 };
#if RF_OPT_USE_RF_PART
    rf_part_param_t pp = { 0 };
#endif
#ifdef RF_OPT_PCMCU_PLAT
    rf_char_t DEV_NAME1[RF_MAX_PATH], DEV_NAME2[RF_MAX_PATH];
#else
#define DEV_NAME1 "disk1"
#define DEV_NAME2 "disk2"
#endif

    printf("rfs-ver= %s\n", RF_OPT_VERSION);

    /* ʼļϵͳ */
    ret = rf_init();
    check_ret_error_stop("rf_init", ret);

#ifdef RF_OPT_PCMCU_PLAT
    init_img_file(DEV_NAME1, DEV_NAME2);
#endif

    /* ʽu */
#if RF_OPT_USE_MKFS
    format_ex(DEV_NAME1);
    format_ex(DEV_NAME2);
#endif

    /* ʾ豸ʹö */
#if RF_OPT_USE_RF_PART
    ret = rf_part(DEV_NAME1, &pp);
    check_ret_error_stop("rf_part", ret);
    for (i = 0; i < pp.count; i++)
        printf("%lld\t\t%lld\n", pp.part[i].start, pp.part[i].size);
    /*
    ʹ÷
    param.part_count Ϊǰ豸Ч
    if( param.part_count >= 2 )
    {
        /豸һ a:
        mctx.volume_offset =  param.part[0].start;
        mctx.sector_size = 0;
        ret = rf_mount( DEV_NAME1, "a:", "fat", RF_O_RDWR, &mctx);

        豸ڶ b:
        mctx.volume_offset =  param.part[1].start;
        mctx.sector_size = 0;
        ret = rf_mount( DEV_NAME1, "b:", "ntfs", RF_O_RDWR, &mctx);
    }
    */
#endif

    /* дʽu صa: */
    /* Ĳ ֵֻ֧һ */
    mc.volume_offset = 0;
    mc.sector_size = 0;
    ret = rf_mount(DEV_NAME1, "a:", "fat", RF_O_RDWR, &mc);
    check_ret_error_stop("rf_mount", ret);

    /* صڶ豸 b:*/
    mc.volume_offset = 0;
    mc.sector_size = 0;
    ret = rf_mount(DEV_NAME2, "b:", "fat", RF_O_RDWR, &mc);
    check_ret_error_stop("rf_mount", ret);

    /* ȡÿռ */
    ex_statfs();
    /* չļС ڿдļ */
    truncate_ex("\\aaa.txt");
    /* ɾļ */
    rm_file_ex("\\aaa.txt");
    /* ļʾ */
    long_name_ex();
    /* Ŀ¼ʾ */
    ex_mkdir();
    /* ʾдļ */
    ex_write_file();
    /* ʾļ */
    ex_read_file();
    /* ȡļռÿռ ʱ */
    ex_statfile();
    /* ļʱ */
    ex_timefile();
    /* öĿ¼ */
    readdir_ex();
    /* ݿռ伫С ٶдļ */
    sector_read_ex();

    /* ļ   */
    multi_file_ex();

    /* ļǷй© */
#if RF_OPT_USE_GET_HANDLE_COUNT
    if (rf_get_file_handle_count(NULL) != 0)
        check_ret_error_stop("file handle leaked\n", 1);
#endif

    /* ж̷ */
    ret = rf_unmount("a:");
    check_ret_error_stop("rf_umount", ret);
    ret = rf_unmount("b:");
    check_ret_error_stop("rf_umount", ret);

    /* rfs˳ */
#if RF_OPT_USE_RFS_EXIT
    ret = rf_exit();
    check_ret_error_stop("rf_exit", ret);
#endif
    return 0;
}
