#include <stdio.h>
#include "rfs.h"
#include "ex-rfs.h"

static rf_int_t remove_directory(const rf_char_t* path)
{
    rf_int_t ret, fd;
    rf_stat_t st;
    rf_dirent_t dir;
    rf_u32_t i = 0;

    fd = rf_open(path, RF_O_RDONLY);
    check_ret_error_stop("rf_open", fd);

    do {
        /* жǷļ */
        ret = rf_fstat(fd, &st);
        check_ret_error_stop("rf_fstat", ret);
        if (!(st.st_mode & RF_ATTR_DIRECTORY)) {
            ret = RF_ENOTDIR;
            break;
        }

        /* жĿ¼ǷΪ ֻɾյĿ¼ ᵼĿ¼ļ޷ɾ */
        dir.len = 0;
        dir.name = NULL;
        for (i = 0;; i++) {
            ret = rf_readdir_i(fd, &dir);
            if (ret < 0) {
                if (rf_errno == RF_ENDFILE)
                    break;
                check_ret_error_stop("rf_close", ret);
            }
        }
        if (i > 2) {
            ret = 1;
            printf("rmdir: failed to remove `%s`: Directory not empty\n", path);
            break;
        }

        ret = rf_fdelete(fd);
        check_ret_error_stop("rf_fdelete", ret);
        break;
    } while (1);

    rf_close(fd);
    return ret;
}

int ex_mkdir()
{
    rf_int_t ret;

    ret = rf_mkdir("testdir");
    check_ret_error_stop("rf_mkdir", ret);

    ret = rf_mkdir("testdir\\23456");
    check_ret_error_stop("rf_mkdir", ret);

    ret = rf_mkdir("testdir\\23456\\qaz");
    check_ret_error_stop("rf_mkdir", ret);

    ret = remove_directory("testdir\\23456\\qaz");
    check_ret_error_stop("remove_directory", ret);

    return 0;
}
