#include <stdio.h>
#include "rfs.h"
#include "ex-rfs.h"

static rf_int_t cread_dir_filr(rf_char_t* dir)
{
    rf_int_t ret, i;
    rf_int_t fd;
    rf_char_t buf[16];

    ret = rf_mkdir(dir);
    check_ret_error_stop("rf_mkdir", ret);

    for (i = 0; i < 10; i++) {
        sprintf(buf, "%s\\%d", dir, i);
        fd = rf_open(buf, RF_O_CREAT | RF_O_WRONLY | RF_O_TRUNC);
        check_ret_error_stop("rf_mkdir", fd);
        rf_close(fd);
    }
    return 0;
}

static rf_int_t read_dir(rf_char_t* dir)
{
    rf_int_t ret, fd;
    rf_dirent_t dt;
    rf_char_t buf[RF_MAX_FNAME];

    fd = rf_opendir_i(dir);
    check_ret_error_stop("rf_opendir_i", fd);

    dt.name = buf;
    dt.len = sizeof(buf);
    for (;;) {
        ret = rf_readdir_i(fd, &dt);
        if (ret < 0) {
            if (RF_ENDFILE == rf_errno)
                break;
            check_ret_error_stop("rf_readdir_i", ret);
        }
        printf("%s\n", dt.name);
    }
    rf_closedir_i(fd);
    return 0;
}

rf_int_t readdir_ex()
{
    cread_dir_filr("\\1234");
    read_dir("\\1234");
    return 0;
}