/*!The RanFs Library
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Copyright (C) 2014-2019, www.ranfs.com
 *
*/
#ifndef __RF_CODEPAGE_H__
#define __RF_CODEPAGE_H__

#define IsUpper(c)          (((c)>='A')&&((c)<='Z'))
#define IsLower(c)          (((c)>='a')&&((c)<='z'))
#define IsDigit(c)          (((c)>='0')&&((c)<='9'))

#if RF_OPT_HAVE_CODE_PAGE

#define mb_bytes()          cp_bytes( g_path_code_page )
#define sb_upper_ex(chr)    cp_sb_upper_ex( chr, g_path_code_page )

#define isdbcs1(chr)        cp_isdbcs_1_2( chr, 1, g_path_code_page )
#define isdbcs2(chr)        cp_isdbcs_1_2( chr, 2, g_path_code_page )

#define w2a(chr)            cp_convert( chr, 0, g_path_code_page )
#define a2w(chr)            cp_convert( chr, 1, g_path_code_page )

#define wtoupper(chr)       cp_wtoupper( chr )

rf_wchar_t cp_convert(rf_wchar_t chr, rf_int_t dir, rf_int_t cp);
rf_wchar_t cp_wtoupper(rf_wchar_t chr);
rf_int_t cp_bytes(rf_int_t cp);
rf_int_t cp_isdbcs_1_2(rf_char_t chr, rf_int_t flag, rf_int_t cp);
rf_char_t cp_sb_upper_ex(rf_char_t chr, rf_int_t cp);

rf_wchar_t w2A(rf_wchar_t chr);
rf_wchar_t e2A(rf_wchar_t chr);
rf_int_t str2cp(rf_char_t* cp);
rf_char_t* wchar_to_utf8(rf_u32_t wc, rf_char_t* output, rf_int_t outsize, rf_int_t* outlen);

extern rf_int_t g_path_code_page;
#define RF_NOW_CODE_PAGE        g_path_code_page
#else

#define mb_bytes( )             1
#define isdbcs1(char)           0
#define RF_NOW_CODE_PAGE        0

#endif

#endif
