/*!The RanFs Library
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Copyright (C) 2014-2019, www.ranfs.com
 *
*/
#ifndef __RF_STRING_H__
#define __RF_STRING_H__

rf_wchar_t rf_wchr_chk(const rf_wchar_t* str, rf_wchar_t chr);
rf_size_t rf_wstrlen(const rf_wchar_t* str);
rf_int_t rf_wcscmp(const rf_wchar_t* src, const rf_wchar_t* dst);
rf_int_t rf_wstrncmp_buf(rf_u8_t* buf, rf_u16_t idx, rf_wchar_t* b, rf_u16_t n);
rf_wchar_t* rf_wstrcpy(rf_wchar_t* dst, const rf_wchar_t* src);
rf_wchar_t* rf_a2w_strcpy(rf_wchar_t* dst, const rf_char_t* src);
rf_bool_t rf_wstr_contain_wild_cards(const rf_wchar_t* string);

rf_char_t rf_chr_chk(const rf_char_t* str, rf_char_t chr);
rf_bool_t rf_str_contain_wild_cards(const rf_char_t* string);

rf_int_t rf_strcpy_s(rf_char_t* dest, rf_int_t len, const rf_char_t* src);
rf_int_t rf_strcat_s(rf_char_t* dest, rf_int_t len, const rf_char_t* src);
rf_int_t rf_str_replace_all(rf_char_t* str, rf_char_t old_char, rf_char_t new_char);

#endif