/*!The RanFs Library
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Copyright (C) 2014-2019, www.ranfs.com
 *
*/
#ifndef __RF_ARCH_H__
#define __RF_ARCH_H__

rf_void_t rf_assert_handler(const rf_char_t* file, rf_int_t line);

#if defined( RF_OPT_PC_PLAT ) || defined(RF_OPT_PCMCU_PLAT)
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "liblog.h"

#define rf_malloc malloc
#define rf_free free
#define RF_PLATFORM_PRINTF(x)   do { log_error x;} while(0)
#define RF_PLATFORM_ASSERT(x) do { log_error(x); rf_assert_handler(__FILE__, __LINE__);}while(0)
#else
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define rf_malloc malloc
#define rf_free free
#define RF_PLATFORM_PRINTF(x)   do { printf x;} while(0)
#define RF_PLATFORM_ASSERT(x) do { printf(x); rf_assert_handler(__FILE__, __LINE__);}while(0)
#endif

#endif
