#ifndef _WIN32_DEV_H_
#define _WIN32_DEV_H_

#ifdef __cplusplus
extern "C" {
#endif

struct _dev_context_t {
    rf_u32_t type;
    rf_handle_t handle;
    rf_u32_t sector_size;
    rf_lloff_t volume_offset;
    rf_lloff_t file_size;
};
typedef struct _dev_context_t rf_disk_context_t, *rf_disk_context_ref_t;

rf_int_t win_open(const rf_char_t* device_name, rf_int_t flags, rf_void_t* ctx, rf_handle_t* hdev);
rf_int_t win_close(rf_handle_t dev);
rf_int_t win_ioctl(rf_handle_t dev, rf_int_t cmd, rf_void_t* buf, rf_int_t len);
rf_int_t win_read(rf_handle_t dev, rf_lloff_t sector_offset, rf_u32_t sector_count, rf_void_t* buf);
rf_int_t win_write(rf_handle_t dev, rf_lloff_t sector_offset, rf_u32_t sector_count, rf_void_t* buf);


#ifdef __cplusplus
}
#endif

#endif

